<?php
require_once "connect.php";
require_once "inc/messages.php";

/*
 * Status da solicitação:
 * 
 * 1 = AGUARDANDO APROVAÇÃO
 * 2 = APROVADA
 * 3 = CANCELADA
 *    
 */

if(isset($_POST['btn-cotar'])) {
	
    $id_solicitacao_compra_item	= $_POST['id_solicitacao_compra_item'];	
    $id_solicitacao_compra = $_POST['id_solicitacao_compra'];
    $id_cotacao_compra = $_POST['id_cotacao_compra'];
    $id_comprador = $_POST['id_comprador'];
    
    $sql_delete = "delete from erpc_cotacao_compra_itens where id_solicitacao_compra_item = $id_solicitacao_compra_item";
    $stmt_delete = mysqli_prepare($conexao, $sql_delete) or die(mysqli_error($conexao) . '<br />' . $sql);
    mysqli_stmt_execute($stmt_delete) or die (mysqli_error($conexao));
	
	foreach($_POST['itens'] as $itens){
		
	   // $str_vl_unit = $itens['vl_unitario'];
	   // $str_vl_unit_neg = $itens['vl_unit_negociado'];
	    
	    
	    $array_vl_produto = explode("$",$itens['vl_produto']);
	    
	    $vl_produto = str_replace(",",".",str_replace(".","",$array_vl_produto[1]));
	    
	    $array_vl_negociado = explode("$",$itens['vl_negociado']);
	    
	    $vl_negociado = str_replace(",",".",str_replace(".","",$array_vl_negociado[1]));
	    

	$sql_itens = "insert into erpc_cotacao_compra_itens (id_cotacao_compra
                                                        ,id_solicitacao_compra_item
														,id_fornecedor
														,vl_produto
														,vl_negociado
														,dt_disponibilidade
                                                        ,st_aprovada
														,st_ativo) values
														( $id_cotacao_compra
                                                        ,$id_solicitacao_compra_item
														,'" . $itens['id_fornecedor'] . "'
														,'" . $vl_produto . "'
														,'" . $vl_negociado . "'
														,str_to_date('" . $itens['dt_disponibilidade'] . "', '%d/%m/%Y')
                                                        ,0
														,1)";

	$stmt_itens = mysqli_prepare($conexao, $sql_itens) or die(mysqli_error($conexao));
    mysqli_stmt_execute($stmt_itens) or die(mysqli_error($conexao));
    

    $sql_comprador = "update erpc_cotacao_compra set id_comprador = $id_comprador 
                        where id = $id_cotacao_compra";

	$stmt_comprador = mysqli_prepare($conexao, $sql_comprador) or die(mysqli_error($conexao));
	mysqli_stmt_execute($stmt_comprador) or die(mysqli_error($conexao));
  
  //Voltando para lista
    $id_crip = base64_encode($id_cotacao_compra);
	}
	header("Location:erpc_cotacao_compra_detalhe.php?id=" . $id_crip);

}//fim editar

if(isset($_POST['btn-remove'])) {
	
	$id = $_POST['id'];	
 

	 $sql = "update erpc_solicitacao_compra set st_ativo = 0 where id = $id";
	 
  	$stmt = mysqli_prepare($conexao, $sql) or die(mysqli_error($conexao) . '<br />' . $sql);
	 mysqli_stmt_execute($stmt) or die (mysqli_error($conexao));	
	
	

		

 header("Location:erpc_cotacao_compra_detalhe.php");

}//fim remover

if(isset($_POST['btn-aprovar'])) {
    $id_cotacao_compra = $_POST['id_cotacao_compra'];
    $id_responsavel    = $_POST['id_responsavel'];
    $produtos = array();
    $st_aprovada       = 1; //aprovada

    if(isset($_POST['produtos'])){
        $produtos= $_POST['produtos'];
        $itens   = "0";

        /* Percorrer os itens para verificar Negociado x Alçada */
        foreach ($produtos as $cotacao => $item) {
            if(isset($item['id_cotacao_compra_item'])){
                $itens .= "," . $item['id_cotacao_compra_item'];

                // $vl_negociado += floatVal(preg_replace("/[^0-9]/", "", $item['vl_total_negociado']) / 100);
            }
        }
    
        $sql_maximo = "select erpc_grupo_alcada.vl_maximo
                    from erpc_grupo_alcada 
                    inner join erpc_usuarios
                    on erpc_usuarios.id_grupo_alcada = erpc_grupo_alcada.id
                    where erpc_usuarios.id =" . $id_responsavel;

        $sql_total = "select sum((ci.vl_negociado * si.nr_quantidade)) as vl_total_negociado
                        from erpc_cotacao_compra_itens ci
                        inner join erpc_solicitacao_compra_itens si
                        on ci.id_solicitacao_compra_item = si.id
                        where ci.id_cotacao_compra = $id_cotacao_compra 
                          and ci.id in( $itens )";

        $resultado_maximo = mysqli_query($conexao,$sql_maximo) or die(mysqli_error($conexao));
        $resultado_total  = mysqli_query($conexao,$sql_total) or die(mysqli_error($conexao));
     
        if(mysqli_num_rows($resultado_maximo) > 0){
            while($registro = mysqli_fetch_array($resultado_maximo)){
                $vl_maximo = $registro['vl_maximo'];

            }
        }
        if(mysqli_num_rows($resultado_total) > 0){
            while($registro = mysqli_fetch_array($resultado_total)){
                $vl_total_negociado = $registro['vl_total_negociado'];
                
            }
        }

        /*
        echo "<br>sql_maximo|$sql_maximo";
        echo "<br>sql_total|$sql_total";
        echo "<br>vl_maximo|$vl_maximo";
        echo "<br>vl_total_negociado|$vl_total_negociado";

        echo "<pre>";
        print_r($produtos);
        echo "</pre>";
        exit;
        */

        $contador_aprovados = 0;   
        if($vl_maximo >= $vl_total_negociado){           
            foreach ($produtos as $cotacao => $item) {
                if(isset($item['id_cotacao_compra_item'])){
                    $id_cotacao_compra_item     = $item['id_cotacao_compra_item'];
                    $id_solicitacao_compra_item = $item['id_solicitacao_compra_item'];
                
                    $sql = "update  erpc_cotacao_compra_itens
                                set st_aprovada=$st_aprovada
                            where  id = $id_cotacao_compra_item";
                    
                    $stmt = mysqli_prepare($conexao, $sql) or die(mysqli_error($conexao) . '<br />' . $sql);
                    mysqli_stmt_execute($stmt) or die (mysqli_error($conexao));
                    
                    $sql2 = "update erpc_solicitacao_compra_itens
                                set vl_unit_cotado = (
                                    select  IFNULL(vl_negociado, 0)
                                    from    erpc_cotacao_compra_itens
                                    where   id = $id_cotacao_compra_item limit 1)
                            where   id = $id_solicitacao_compra_item";
                    
                    $stmt2 = mysqli_prepare($conexao, $sql2) or die(mysqli_error($conexao) . '<br />' . $sql2);
                    mysqli_stmt_execute($stmt2) or die (mysqli_error($conexao)); 
                    
                    $sql3 = "update  erpc_cotacao_compra
                                set id_responsavel_aprov = $id_responsavel 
                            where  id = $id_cotacao_compra";
                    
                    $stmt3 = mysqli_prepare($conexao, $sql3) or die(mysqli_error($conexao) . '<br />' . $sql);
                    mysqli_stmt_execute($stmt3) or die (mysqli_error($conexao));

                    /*
                    $sql4 = "update  erpc_cotacao_compra_itens
                                set st_ativo = 0 
                            where  id = $id_cotacao_compra and not id = $id_cotacao_compra_item";
                    
                    $stmt4 = mysqli_prepare($conexao, $sql4) or die(mysqli_error($conexao) . '<br />' . $sql);
                    mysqli_stmt_execute($stmt4) or die (mysqli_error($conexao));
                    */
                    $contador_aprovados ++;
                }
            }
        }
        if($contador_aprovados>0){
            AddMessage("Aprovado $contador_aprovados itens da Cotação Número: $id_cotacao_compra");
        }else{
            $msg = "Não foi possível aprovar Cotação Número $id_cotacao_compra | tem selecionado inválido ou verifique o ";
            $msg.= "limite de Alçada R$ " . number_format($vl_maximo, 2, ",", "");
            AddError($msg);
        }
    }

     /*
     echo "<br>id_cotacao_crip:$id_cotacao_crip";
     echo "<pre>";
     print_r( $_POST);
     echo "</pre>";
     exit;
     */
    // $id_cotacao_crip = base64_encode($id_cotacao_compra);
    header("Location:erpc_cotacao_compra_list.php");
}

if(isset($_POST['btn-cancelar'])) {
    
    $id_solicitacao_compra_item	= $_POST['id_solicitacao_compra_item'];
    $id = $_POST['id_solicitacao_compra'];
    $id_usuario = $_POST['id_usuario'];
    $id_status_solicitacao 		= 3; //cancelada
    
    
    $sql_alcada = "select erpc_grupo_alcada.vl_maximo
                    from erpc_grupo_alcada inner join erpc_usuarios
                    on erpc_usuarios.id_grupo_alcada = erpc_grupo_alcada.id
                    where erpc_usuarios.id =" . $id_usuario;
    
    $resultado_alcada = mysqli_query($conexao,$sql_alcada) or die(mysqli_error($conexao));
    
    if(mysqli_num_rows($resultado_alcada) > 0){
        while($registro = mysqli_fetch_array($resultado_alcada)){
            $vl_maximo = $registro['vl_maximo'];
            
            
            foreach($id as $ids){
                $id_array .= " , " . $ids;
            }
            
            
            $sql = "update erpc_solicitacao_compra 
                        set id_status_solicitacao = " . $id_status_solicitacao . 
                        ",id_responsavel_aprov = " . $id_usuario . 
                        " where id in (0" . $id_array . " )
                        and vl_total <=" . $vl_maximo;
            
            // echo $sql;
            
            $stmt = mysqli_prepare($conexao, $sql) or die(mysqli_error($conexao) . '<br />' . $sql);
            mysqli_stmt_execute($stmt) or die (mysqli_error($conexao));
            
            
            
            
        }
    }
    
    
    
    
    
    header("Location:erpc_cotacao_compra_detalhe.php?id=" . $id);
    
}

if(isset($_GET['remover'])) {

    $id_crip = $_GET['id'];
    $id = base64_decode($id_crip);

    $sql = "update erpc_cotacao_compra set st_ativo = 0 where id = $id";

    $stmt = mysqli_prepare($conexao, $sql) or die(mysqli_error($conexao) . '<br />' . $sql);
    mysqli_stmt_execute($stmt) or die (mysqli_error($conexao));

    header("Location:erpc_cotacao_compra_list.php");

}


?>